<p>This is a more complete example with a service that simulates server calling:</p>

<ul>
  <li>an observable async service to fetch a list of countries</li>
  <li>sorting, filtering and pagination</li>
  <li>simulated delay and loading indicator</li>
  <li>debouncing of search requests</li>
</ul>

<form>
  <div class="form-group form-inline">
    Full text search: <input class="form-control ml-2" type="text" name="searchTerm" [(ngModel)]="service.searchTerm"/>
    <span class="ml-3" *ngIf="service.loading$ | async">Loading...</span>
  </div>

  <span class="table-add float-right mb-3 mr-2">
      <a class="text-success" (click)="add()">
        Add
        <!--<mdb-icon fas icon="plus" size="2x"></mdb-icon>-->
      </a>
    </span>

  <table class="table table-striped">
    <thead>
    <tr>
      <th scope="col">#</th>
      <th scope="col" sortable="name" (sort)="onSort($event)">Country</th>
      <th scope="col" sortable="area" (sort)="onSort($event)">Area</th>
      <th scope="col" sortable="population" (sort)="onSort($event)">Population</th>
    </tr>
    </thead>
    <tbody>
    <tr *ngFor="let country of countries$ | async">
      <th scope="row">{{ country.id }}</th>
      <td>
        <img [src]="'https://upload.wikimedia.org/wikipedia/commons/' + country.flag" class="mr-2" style="width: 20px">
        <ngb-highlight [result]="country.name"
                       [term]="service.searchTerm"
                       (keyup)="service.changeValue(country.id, 'name', $event)"
                       (blur)="service.updateList(country.id, 'name', $event)"
                       contenteditable="true"
        ></ngb-highlight>
      </td>
      <td><ngb-highlight [result]="country.area | number" [term]="service.searchTerm"></ngb-highlight></td>
      <td><ngb-highlight [result]="country.population | number" [term]="service.searchTerm"></ngb-highlight></td>
    </tr>
    </tbody>
  </table>

  <div class="d-flex justify-content-between p-2">
    <!--START, CENTER, end -->
    <ngb-pagination class="d-flex justify-content-center"
                    (pageChange)="onPageChange($event)"
                    (changePage)="onChangePage($event)"
                    [collectionSize]="total$ | async"
                    [(page)]="service.page"
                    [pageSize]="service.pageSize"
                    [boundaryLinks]="true"
                    [directionLinks]="false"
                    [maxSize]="2"
                    [rotate]="true"
                    [ellipses]="false"
                    size="sm"
                    aria-label="Custom pagination">
      <ng-template ngbPaginationPrevious>Prev</ng-template>
      <ng-template ngbPaginationNext>Next</ng-template>
      <ng-template ngbPaginationNumber let-p>{{ getPageSymbol(p) }}</ng-template>
    </ngb-pagination>

    <hr>

    <pre>Current page: {{service.page}}</pre>


    <select class="custom-select" style="width: auto" name="pageSize" [(ngModel)]="service.pageSize">
      <option [ngValue]="2">2 items per page</option>
      <option [ngValue]="4">4 items per page</option>
      <option [ngValue]="6">6 items per page</option>
    </select>
  </div>

</form>
